#! /usr/bin/env python


template = """<sdnConfig>
<sdn::StackedNetworkConfig error_averaging_timeconstant=".001" input_width="14" input_height="14" normalize_contrast="1">  
 <Architecture> 
   <sdn::Autoencoder num_hidden="{0}" learning_rate="{1}"   learning_rate_sparsity="{2}"  target_sparsity="{3}" weight_decay="{4}" sparsity_averaging_timeconstant=".001"/> 
</Architecture> 
</sdn::StackedNetworkConfig> 
<UseTrainCallbacks> 
  <sdn::TrainCallback id="sdn::PatchVizCallback" firstIter="0" step="50000" showImage="0" saveFile="1" filepath="reconstructions.png" normalize_contrast="1"/> 
  <sdn::TrainCallback id="sdn::WeightsVisualizationCallback" step="50000" /> 
  <sdn::TrainCallback id="sdn::SparsityVisualizationCallback" step="10000" filename="sparsity.dat"/> 
  <sdn::TrainCallback id="sdn::TrainingErrorVisualizationCallback" step="10000" filename="training_error.dat"/>
  <sdn::TrainCallback id="sdn::SaveFileCallback" step="500000" basename="network"/>
  <sdn::TrainCallback id="sdn::GratingTestQuantileThresholdCallback" step="250000" filename="grating_invariance.dat"/>
  <sdn::TrainCallback id="sdn::ParamsCallback" iter="500000" >
    <Params>
      <layerUpdate layer="0" learning_rate="{5}"/>
    </Params>
  </sdn::TrainCallback>
  <sdn::TrainCallback id="sdn::ParamsCallback" iter="1800000" >
    <Params>
      <layerUpdate layer="0" learning_rate="{6}"/>
    </Params>
  </sdn::TrainCallback>
  <sdn::TrainCallback id="sdn::EndTrainingCallback" iter="2001000"/>
  </UseTrainCallbacks>  
</sdnConfig>"""

#decades = [-2]
learning_rates = [.003]
#for i in decades:
#    learning_rates.append(10**i)

#decades = [10]
learning_rate_sparsities = [30]
#for i in decades:
#    learning_rate_sparsities.append(10**i)

#Note: -1 is interpreted as zeroing out the sparisty learning rate
target_sparsities = [-1, 0.0125, 0.0175, 0.02, 0.035, .05, .075, .1]

#decades = []
weight_decays = [.023, .015, .01, .006, .0045, .003, .002, .001, .0001, 0]
#for i in decades:
#    weight_decays.append(10**i)

num_hiddens = [400]

import os

batchname = "batch_layer1_lr_schedule/"

os.mkdir(batchname)

idx = 0
for learning_rate in learning_rates:
    for learning_rate_sparsity in learning_rate_sparsities:
        for target_sparsity in target_sparsities:
            for weight_decay in weight_decays:
                for num_hidden in num_hiddens:
                    if target_sparsity == -1:
                        target_sparsity = 0.5
                        learning_rate_sparsity = 0
                    
                    
                    runname = "run_{0}/".format(idx)
                    os.mkdir(batchname + runname);
                    
                    filename = batchname + runname + "config.xml"
                    f = open(filename, 'w')
                    
                    f.write( template.format(num_hidden, learning_rate, learning_rate_sparsity, target_sparsity, weight_decay, learning_rate/10, learning_rate/100) )
                    f.close()
                    
                    idx = idx + 1

                    if learning_rate_sparsity == 0:
                        learning_rate_sparsity = 30
                    
                    
