#!/bin/env bash
#Author: Ian Goodfellow
#Description: Run this script from the trunk directory of libsdn to run all
# of the tests and then commit

success=1;
make || success=0;

if [[ "${success}" == "0" ]]
then
	echo "Could not build the library or applications. Please fix before committing";
	exit 1;
fi

bash scripts/runTests.sh || success=0;

if [[ "${success}" == "0" ]]
then
	echo "Some tests failed. Please fix before committing";
	exit 1;
fi

svn commit

