#!/bin/env bash
#Author: Ian Goodfellow
#Description: Run this script from the trunk directory of libsdn to run all
# of the tests

success=1;
make tests || success=0;

if [[ "${success}" == "0" ]]
then
	echo "Could not build the tests";
	exit 1;
fi

failed="";
pushd tests/bin;

apps="`echo *`"
for app in ${apps}; do
	thisSuccess=1
	./${app} || thisSuccess=0
	if [[ "${thisSuccess}" == "0" ]];
	then
		success=0;
		failed+="${app} ";
	fi
done;

popd >& /dev/null;


if ! [[ "${success}" == "1" ]];
then
	echo "Failed tests: ${failed}";
	exit 1;
else
	exit 0;
fi
