#include <iostream>  // I/O 
#include <vector>
#include "sdn/dataset.h"
#include "sdn/old.h"
#include "sdn/base.h"
#include "boost/shared_ptr.hpp"
using namespace std; 
using namespace sdn; 

using namespace boost;


int main(int argc, char *argv[]){
  
  if (argc < 2){
    cout << "please specify a network file." << endl;
    return 0;
  }
  GratingTestDataset *itd;			
  ifstream ifs(argv[1]);
  serial::BinInArchive ar(ifs);
  shared_ptr<Network> network = NetworkRegistry().load(ar);
  itd = new GratingTestDataset(network->getInputCols(), network->getInputRows());
  Scalar networkScoreOut;
  Scalar templateScoreOut;
  Scalar maxpoolingScoreOut;
  vector<Scalar> scorePerCategory;
  firingRateTest(network,
		 *itd,
		 0.99, // quantile QVL: hack hardcode
		 0.1,
		 networkScoreOut,
		 templateScoreOut,
		 maxpoolingScoreOut,
		 scorePerCategory);
  cout << "grating test, network score " << networkScoreOut << endl;
  return 0;

}

