#include <iostream>  // I/O 
#include <vector>
#include "sdn/dataset.h"
#include "sdn/old.h"
#include "sdn/base.h"
#include "boost/shared_ptr.hpp"
using namespace std; 
using namespace sdn; 

using namespace boost;


int main(int argc, char *argv[]){
  
  if (argc < 2){
    cout << "please specify a network file." << endl;
    return 0;
  }
  GratingTestDataset *itd;			
  

  cout << "trying to load " << endl;
  ifstream ifs(argv[1]);
  serial::BinInArchive ar(ifs);
  shared_ptr<Network> network = NetworkRegistry().load(ar);
  cout << "done " << endl;
  itd = new GratingTestDataset(network->getInputCols(), network->getInputRows());
  Scalar networkScoreOut;
  Scalar templateScoreOut;
  Scalar maxpoolingScoreOut;
  gratingTestVarianceRatio(network,
			   *itd,
			   networkScoreOut,
			   templateScoreOut,
			   maxpoolingScoreOut);
  cout << "grating test, network score " << networkScoreOut << endl;
  return 0;

}

