#include "sdn/old.h"
#include "sdn/gui.h"
#include <vector>

#define QPI 3.14159265358979323846264338
using namespace sdn;
using namespace std;

/* This seems to work best:
 * orientations from 0 to PI discretized 40 
 * frequences from 2 to 4 discretized 2
 * phases from 0 to PI discretized 8
 */

int main(int argc, char ** argv)
{

  PatchDisplay v("sample gratings",14,14,2,20,20);
  Grating g(14,14,-0.6,0.6);

  v.enableWindow();
  
  vector<Scalar> orientations;
  Scalar minAngle = 0;
  Scalar maxAngle = QPI;
  Scalar numAngle = 10;
  Scalar deltaAngle = (maxAngle - minAngle) / numAngle;
  for (unsigned int i=0;i<=numAngle;i++){
    orientations.push_back(minAngle + i*deltaAngle);
  }

  vector<Scalar> frequencies;
  Scalar minFrequency = 2;
  Scalar maxFrequency = 4;
  Scalar numFrequency = 2;
  Scalar deltaFrequency = (maxFrequency - minFrequency) / numFrequency;
  for (unsigned int i=0;i<=numFrequency;i++){
    frequencies.push_back(minFrequency + i*deltaFrequency);
  }

  vector<Scalar> phases;
  Scalar minPhase = 0;
  Scalar maxPhase = QPI;
  Scalar numPhase = 4;
  Scalar deltaPhase = (maxPhase - minPhase) / numPhase;
  for (unsigned int i=0;i<=numPhase;i++){
    phases.push_back(minPhase + i*deltaPhase);
  }
  

  for (unsigned int j=0;j<frequencies.size();j++){
    for (unsigned int i=0;i<phases.size(); i++){
      for (unsigned int k=0;k<orientations.size();k++){
	g.setPhaseShift(phases[i]);
	g.setOrientation(orientations[k]);
	g.setFrequency(frequencies[j]);
	
	Matrix m = g.getImage();
	
	v.addPatch(m);
	
	v.wait(25);
      }
    }
  }
  v.showAndStop();
  v.saveImage("test.jpg");
  
  /*while (true)
    {
      Scalar t;
      Scalar p;
      Scalar f;
      
      cout << "orientation: ";
      cin >> t;
      cout << "phase: ";
      cin >> p;
      cout << "frequency: ";
      cin >> f;

      g.setPhaseShift(p);
      g.setOrientation(t);
      g.setFrequency(f);

      Matrix m = g.getImage();

      v.addPatch(m);

      v.wait(25);

      v.saveImage("foo.jpg");
    }
  */

  return 0;
}
