// Copyright 2009, All Rights Reserved.
// Author: Quoc V. Le (quocle@cs.stanford.edu)
/** \file testplotter.cc
    \brief A test class for the visualizer
*/
#include <iostream>
#include <cv.h>
#include <highgui.h>
#include "sdn/gui.h"
using namespace std;
using namespace sdn; 
USING_PART_OF_NAMESPACE_EIGEN // import most common Eigen types 

int main(int argc, char *argv[])
{
  Plotter p;
  int numpoints = 10;
  MatrixXd x;
  x = MatrixXd::Random(1, numpoints);
  MatrixXd y;
  y = MatrixXd::Random(1, numpoints);
  for (int i=0;i<numpoints;i++){
    y[i] = i*i;
  }
  string filename1 = "testimage1";
  //p.PlotAndSave(x, y, filename.c_str());
  p.PlotAndSave(y, filename1.c_str());
  //p.PlotAndShow(x, y);
  

  vector<double> v;
  vector<double> w;
  for (int i=0;i<numpoints;i++){
    v.push_back(x[i]);
    w.push_back(y[i]);
  }
  string filename2 = "testimage2";
  p.PlotAndSave(w, filename2.c_str());
  cout << "The images are saved as " << filename1 << ".png and " << filename2 << ".png" << endl;
}
