//Author: Ian Goodfellow
//File: Archive

#include "logger.h"
#include "archive.h"
#include <sstream>
#include <assert.h>
using namespace std;
using namespace sdn;
using namespace serial;


Archive::Archive()
{
}

Archive::~Archive() 
{
  p_.processTerminal(FLUSH); 
}


int Archive::beginBase(void * addr, int version, std::string id)
{
  p_.processTerminal(BEGIN_BASE);
  return beginBase_(addr, version, id);
}

void Archive::endBase()
{
  p_.processTerminal(END_BASE);
  endBase_();
}

void Archive::beginSuper()
{
  p_.processTerminal(BEGIN_SUPER);
  beginSuper_();
}

void Archive::endSuper()
{
  p_.processTerminal(END_SUPER);
  endSuper_();
}

int Archive::beginDerived(void * addr, int version, std::string  id)
{
  p_.processTerminal(BEGIN_DERIVED);
  return beginDerived_( addr,  version, id);
}

void Archive::attribute(std::string name, unsigned & value)
{
  p_.processTerminal(ATTRIBUTE);
  attribute_(name, value);
}

void Archive::attribute(std::string name, double & value)
{
  p_.processTerminal(ATTRIBUTE);
  attribute_(name, value);
}

void Archive::attribute(std::string name, bool & value)
{
  p_.processTerminal(ATTRIBUTE);
  attribute_(name, value);
}

void Archive::attribute(std::string name, int & value)
{
  p_.processTerminal(ATTRIBUTE);
  unsigned temp = value;
  attribute_(name, temp);
  value = temp;
}

void Archive::attribute(std::string name, float & value)
{
  p_.processTerminal(ATTRIBUTE);
  attribute_(name, value);
}

void Archive::attribute(std::string name, std::string & value)
{
  p_.processTerminal(ATTRIBUTE);
  attribute_(name, value);
}

void Archive::scalarArray(Scalar * data, unsigned numFloats)
{
  p_.processTerminal(CUSTOM_CONTENT);
  scalarArray_(data,numFloats);
}

void Archive::endDerived()
{
  p_.processTerminal(END_DERIVED);
  endDerived_();
}
