#include "inArchive.h"

using namespace std;
using namespace sdn;
using namespace serial;

InArchive::InArchive()
{
  expectingReportPointer_ = false;
  hasPeeked_ = false;
}

void InArchive::peek( void * & prevPtr,
			std::string & id, int & version)
{
  SDN_ASSERT_MSG(!expectingReportPointer_, "calls to peek that report that an object has not been serialized yet expect to be followed immediately by calls to reportPointer");
  Vaddr v = peek_(prevPtr,id,version);
  
  if (!prevPtr)
    {
      expectingReportPointer_ = true;
      expectedVaddr_ = v;
      peekedDerivedName_ = id;
      peekedVersion_ = version;
      hasPeeked_ = true;
    }
}

void InArchive::reportPointer(void * p, PointerDeleter * d)
{
  SDN_ASSERT(expectingReportPointer_);
  expectingReportPointer_ = false;
  vaddrToAddr_[expectedVaddr_] = pair<string,void *>("todo-- quit tracking the basename",p);
  deleters_.push_back(d);
}

std::string InArchive::vaddrToBaseName_(Vaddr v)
{
  VaddrToAddr::iterator i = vaddrToAddr_.find(v);
  SDN_ASSERT(i != vaddrToAddr_.end());
  return i->second.first;
}

void * InArchive::vaddrToAddrOfPtr_(Vaddr v)
{
  VaddrToAddr::iterator i = vaddrToAddr_.find(v);
  SDN_ASSERT(i != vaddrToAddr_.end());
  return i->second.second;
}

InArchive::~InArchive()
{
	for (unsigned i = 0; i < deleters_.size(); i++)
		delete deleters_[i];
}
