/// \author Ian Goodfellow

#include "matlabEngine.h"
#include "logger.h"

using namespace boost;
using namespace sdn;

namespace sdn
{
  struct EngineDeleter
  {
    void operator()(void const * p) const
    {
      engClose( (Engine *) p );
    }
  };
}

shared_ptr<Engine> sdn::getSharedMatlabEngine()
{
  shared_ptr<Engine> sharedEngine;
  if (sharedEngine)
    return sharedEngine;

  sharedEngine = shared_ptr<Engine>(engOpen("\0"), EngineDeleter());

  if (!sharedEngine)
    {
      SDN_FATAL("Can't start MATLAB engine");
    }

  return sharedEngine;
}

