/// \author Ian Goodfellow
/// \brief Archive base class for outputing objects

#pragma once

#include "archive.h"

namespace sdn
{
  namespace serial
  {
    //maps an address to virtual address and a list of bools where element i specifies whether descendantdepth[i] has been serialized yet
    typedef std::map<void *, Vaddr > AddrToVaddr;
    

    /// Abstract base class. Implementations determine whether output is XML, binary, etc.
    class OutArchive : public Archive
    {
      
    public:
      
      bool in() { return false; }
      
    protected:
      
      OutArchive();
      
      bool alreadySerialized_(void * o);
      //Call on objects that are serialized already
      Vaddr getVaddr_(void * o);
      //Call on objects that are not serialized already
      Vaddr registerObject_(void * o);
      
      
      AddrToVaddr addrToVaddr_;      
      Vaddr nextVaddr_;
      
    };
        
  }
}
