//Author: Ian Goodfellow
//File: record.h
//Description: A class for recording variables over time throughout an
// experiment

#pragma once

#include <fstream>
#include "xmlUtils.h"

namespace sdn
{

	class Record
	{

		public:
			
			///if no filepath is given, only writes to stdout
			Record( const char * filepath );

			//These may only be called before startRecording
			// returns topic ID to use later
			unsigned addTopic(const std::string & name);
			void addHeaderItem(XMLNode & node);

			void startRecording();

			void recordItem(long long iter, unsigned id, double value);
			void recordItem(long long iter, unsigned id, const std::string & value);

		protected:

			bool toFilepath_;
			std::string filepath_;
			std::ofstream ofs_;
				
	};

}
