/// \author Ian Goodfellow

/*
#include "xmlOutClassBuilder.h"
#include "pointer.h"
#include <sstream>
using namespace std;
using namespace boost;
using namespace sdn;
using namespace serial;

XmlOutClassBuilder::XmlOutClassBuilder()
{
}

shared_ptr<XmlOutClassBuilder> XmlOutClassBuilder::makeDerived(XmlOutArchive * archive, void * addr, int version, std::string id, bool knownToBeSerialized)
{
  shared_ptr<XmlOutClassBuilder> rval = ptr(new XmlOutClassBuilder());
  rval->done_ = false;
  rval->archive_ = archive;
  


  if (knownToBeSerialized || archive->alreadySerialized_(addr))
    {
      rval->alreadySerialized_ = true;
      if (!knownToBeSerialized)
	{
	  SDN_FATAL("todo-- set rval's xml node to be the node encoding the already serialized state, check that rval is allowed to have been serialized already (not a member of a contiguous memory region such as an array or class body)");
	}
    }
  else
    {
      rval->node_ = XMLNode::createXMLTopNode("");
      Vaddr v = archive->registerObject_(addr);
      stringstream t;
      t << v;
      rval->node_.addAttribute("vaddr",t.str().c_str());
      rval->alreadySerialized_ = false;
      stringstream s;
      s << version << endl;
      rval->node_.addAttribute("class_version",s.str().c_str());
      rval->node_.addAttribute("id",id.c_str());
    }

  rval->expectingSuper_ = true;
  rval->parsingSuper_ = false;
  rval->parsedSuper_ = false;
  rval->subclass_ = NULL;
  rval->isDerived_ = true;
  rval->gotSuper_ = false;

  return rval;
}

shared_ptr<XmlOutClassBuilder> XmlOutClassBuilder::makeBase(XmlOutArchive * archive, void * addr, int version, std::string id, bool knownToBeSerialized, XmlOutClassBuilder * subclass)
{
  shared_ptr<XmlOutClassBuilder> rval = ptr(new XmlOutClassBuilder());
  rval->done_ = false;
  rval->archive_ = archive;

  if (knownToBeSerialized || archive->alreadySerialized_(addr))
    {
      rval->alreadySerialized_ = true;
      if (!knownToBeSerialized)
	{
	  SDN_FATAL("todo-- set rval's xml node to be the node encoding the already serialized state, check that rval is allowed to have been serialized already (not a member of a contiguous memory region such as an array or class body) (also, merge this code with makeDerived");
	}
    }
  else
    {
      Vaddr v = archive->registerObject_(addr);
      stringstream t;
      t << v;
      rval->node_.addAttribute("vaddr",t.str().c_str());
      rval->alreadySerialized_ = false;
      stringstream s;
      s << version;      
      rval->node_.addAttribute("class_version",s.str().c_str());
      rval->node_.addAttribute("id",id.c_str());   
      
      if (subclass)
	{
	  rval->node_.updateName("__super__");
	  subclass->setBaseType(id);
	}
    }
  
  rval->subclass_ = subclass;
  rval->parsingSuper_ = false;
  rval->expectingSuper_ = false;
  rval->parsedSuper_ = false;
  rval->isDerived_ = false;
  rval->gotSuper_ = false;

  return rval;
}

void XmlOutClassBuilder::setBaseType(std::string id)
{
  SDN_ASSERT(!done_);
  if (subclass_)
    {
      node_.updateName("__super__");
      subclass_->setBaseType(id);
    }
  else
    node_.updateName(id.c_str());
}

void XmlOutClassBuilder::beginDerived(void * addr, int version, std::string id)
{
  SDN_ASSERT(!done_);
  if (curChild_ != NULL)
    curChild_->beginDerived(addr, version, id);
  else
    {
      curChild_ = makeDerived(archive_, addr, version, id, alreadySerialized_);
      if (expectingSuper_)
	{
	  expectingSuper_ = false;
	  SDN_ASSERT(! parsingSuper_);
	  parsingSuper_ = true;
	  curChild_->subclass_ = this;
	}
    }
}

void XmlOutClassBuilder::beginBase(void * addr, int version, std::string id)
{
  SDN_ASSERT(!done_);
  if (curChild_ != NULL)
    curChild_->beginBase(addr, version, id);
  else
    {
      curChild_ = makeBase(archive_, addr, version, id, alreadySerialized_, this);
      if (expectingSuper_)
	{
	  expectingSuper_ = false;
	  SDN_ASSERT(! parsingSuper_);
	  parsingSuper_ = true;
	}
    } 
}

bool XmlOutClassBuilder::endBase()
{
  SDN_ASSERT(!done_);
  if (curChild_)
    {
      if (curChild_->endBase())
	{
	  if (parsingSuper_)
	    {
	      parsingSuper_ = false;
	      SDN_ASSERT(! parsedSuper_);
	      parsedSuper_ = true;
	    }
	  else
	    {
	      if (!alreadySerialized_)
		node_.addChild(curChild_->getNode());
	      curChild_ = ptr( (XmlOutClassBuilder * ) NULL);
	    }
	}
    }
  else
    {
      SDN_ASSERT(!isDerived_);
      done_ = true;
    }
  return done_;
}

bool XmlOutClassBuilder::endDerived()
{
  SDN_ASSERT(!done_);
  if (curChild_ != NULL)
    {
      if (curChild_->endDerived())
	{
	  if (parsingSuper_)
	    {
	      parsingSuper_ = false;
	      SDN_ASSERT( ! parsedSuper_);
	      parsedSuper_ = true;
	    }
	  else
	    {
	      if (!alreadySerialized_)
		node_.addChild(curChild_->getNode());
	      curChild_ = ptr( (XmlOutClassBuilder * ) NULL);
	    }
	}
    }
  else
    {
      SDN_ASSERT(isDerived_);
      SDN_ASSERT(gotSuper_);
      done_ = true;
    }
  return done_;
}

XMLNode XmlOutClassBuilder::getNode()
{
  SDN_ASSERT(done_);
  return node_;
}

void XmlOutClassBuilder::endSuper()
{
  SDN_ASSERT(curChild_ != NULL)
  if (curChild_->done_)
    {
      SDN_ASSERT(isDerived_);
      node_.addChild(curChild_->getNode());
      curChild_ = ptr( (XmlOutClassBuilder *) NULL);
      parsedSuper_ = false;
      gotSuper_ = true;
    }
  else
    {
      curChild_->endSuper();
    }
}
  
*/
