/// \author Ian Goodfellow
/// \file xmlOutClassBuilder.h
/// \brief A support class for XmlOutArchive

//Ignore this file unless you are changing the way that serialization works
//This should not be a common operation
//Under most circumstances you should only need to write new serialization
//methods for whatever new class you've written that you want to serialize

/*
#pragma once

#include "xmlOutArchive.h"

namespace sdn
{
  namespace serial
  {

    //Builds the XML node for a single class
    class XmlOutClassBuilder
    {            
    protected:
      
      friend class XmlOutArchive;

      static boost::shared_ptr<XmlOutClassBuilder> makeDerived(XmlOutArchive * archive, void * addr, int version, std::string id, bool knownToBeSerialized = false);
      static boost::shared_ptr<XmlOutClassBuilder> makeBase(XmlOutArchive * archive, void * addr, int version, std::string id, bool knownToBeSerialized = false, XmlOutClassBuilder * subclass = NULL);

      void beginDerived(void * addr, int version, std::string id);
      void beginBase(void * addr, int version, std::string id);
      
      //Returns true if this endBase finished this class builder itself (instead of its superclass or a class member)
      bool endBase();
      bool endDerived();

      void endSuper();

      void setBaseType(std::string type);
      XMLNode getNode();

    protected:      
      bool alreadySerialized_;
      //If true, is a derived class and should see a more derived class declared soon (beginSuper is not passed through for OutArchives)
      bool expectingSuper_;
      //If true, has already started parsing a super class, and should be expecting an endSuper
      bool parsingSuper_;
      //If true, has parsed the whole super class and is just waiting for endSuper
      bool parsedSuper_;
      //If true, has finished the super class portion of the object description
      bool gotSuper_;


      XmlOutArchive * archive_;
      boost::shared_ptr<XmlOutClassBuilder> curChild_;
      XmlOutClassBuilder * subclass_;
      XMLNode node_;
      bool isDerived_;
      //true iff endBase/endDerived has been called at this level and getNode is ready to call
      bool done_;
      XmlOutClassBuilder();
      
    };
  }
}
*/
