//Author: Ian Goodfellow
#include "xmlUtils.h"

#include "fileUtils.h"
#include "strUtils.h"
#include "logger.h"
#include <fstream>
#include <assert.h>

using namespace std;
using namespace sdn;

ParseException::ParseException(const XMLResults & results) : runtime_error("xml parse error"), results(results)
{

}


XMLNode sdn::parseXML(string  contents)
{
XMLNode root;

  str::replaceAll(contents,"${SDN_PATH}",sdnPath());
  str::replaceAll(contents,"${CONFIG_PATH}",configPath());


  //Parse the preprocessed string
  XMLResults results;
  root = XMLNode::parseString(contents.c_str(), NULL, &results);

  if (results.error != 0)
    {
      throw ParseException(results);
    }

  //Sometimes the root has no name, even though the file is valid.
  //In these cases it has a single child, which is the real root.
  if (!root.getName())
    {
      if (root.nChildNode() == 1)
	{
	  root = root.getChildNode(0);
	}
    }
  return root;
}

XMLNode sdn::openXML(const char * filepath)
{


  //Read whole file as a string
  ifstream ifs;

  ifs.open(filepath);

  SDN_ASSERT_MSG(!ifs.fail(), "sdn::openXML: could not open file \""<<filepath<<"\"");// todo-- change to throw exceptions, make sure its use in configmanager allows use of main.xml to be optional

  string contents;

  while (true)
    {
      string temp;
      getline(ifs,temp);

      if (ifs.fail())
	break;

      contents += temp +"\n";
    }

  return parseXML(contents);
  //Substitute actual values for ${SDN_PATH} and ${CONFIG_PATH}
  
}
