/// \author Ian Goodfellow
/// \file xmlUtils.h
/** \brief  Provides functions for opening xml files/parsing xml string.
Use these rather than direct calls to the
XML parser library because these preprocess out
glitches from the XML parser library and expands ${SDN_PATH} / ${CONFIG_PATH}
references in the input
*/

#pragma once
#include <stdexcept>
#include "xmlParser/xmlParser.h"



namespace sdn
{
  class ParseException : public std::runtime_error
  {
  public:
    ParseException(const XMLResults & results);
    
    XMLResults results;
  };


  XMLNode openXML(const char * filepath);
  XMLNode parseXML(std::string  str);
}
