#pragma once

#include <map>
#include <list>

#define ALLOC_PAGE_SIZE (65536)

namespace sdn {

  class CudaMemHandler {
  public:
    static float* alloc(int size);
    static void free(float* ptr);

  protected:
    static float* allocLarge(int size);
    static void insertFreeChunk(float* ptr, int size);
    static void clear();

    static std::map<int, std::list<float*> > sizeToPtr;
    static std::map<float*, int> ptrToSize;
    static std::map<float*, int> freeMap;
  };
}
