#include "spectrogramCollectionAMAT.h"
#include "xmlParser/xmlParser.h"
#include "../base/logger.h"

using namespace sdn;
using namespace std;

// TODO make size a configuration option
//const int SpectrogramCollectionAMAT::dataNumRows = 64;
//const int SpectrogramCollectionAMAT::dataNumCols = 10;


SpectrogramCollectionAMAT::SpectrogramCollectionAMAT()
{
  // size not initialized until load is called
  dataNumRows = 0;
  dataNumCols = 0;
  _rows = dataNumRows;
  _cols = dataNumCols;
}

SpectrogramCollectionAMAT::~SpectrogramCollectionAMAT()
{
}

void SpectrogramCollectionAMAT::load(XMLNode & root)
{
  SDN_ASSERT(root.nChildNode() == 0);
  //todo-- change asserts to exception-based error handling
  SDN_ASSERT(root.getName());
  string name = root.getName();
  SDN_ASSERT(name == "sdn::Dataset");
  SDN_ASSERT(root.getAttribute("id"));
  string id = root.getAttribute("id");
  SDN_ASSERT(id == "sdn::SpectrogramCollectionAMAT");
  SDN_ASSERT(root.getAttribute("path"));
  string path = root.getAttribute("path");
  
  ifstream ifs;
  ifs.open(path.c_str());

  SDN_ASSERT(!ifs.fail());

  
  SDN_ASSERT(root.getAttribute("start"));
  int start  = atoi(root.getAttribute("start"));

  SDN_ASSERT(root.getAttribute("numImages"));
  int numImages = atoi(root.getAttribute("numImages"));

  // get size attributes
  SDN_ASSERT(root.getAttribute("width"));
  dataNumCols = atoi(root.getAttribute("width"));

  SDN_ASSERT(root.getAttribute("height"));
  dataNumRows = atoi(root.getAttribute("height"));

  _rows = dataNumRows;
  _cols = dataNumCols;

  //Skip over input preceding our dataset
  for (int i = 0; i < start; i++)
    {
      double temp;
      for (int j = 0; j < dataNumRows*dataNumCols; j++)
	ifs >> temp;
    }

  assert(!ifs.fail());

  _images.resize(numImages,Matrix::Zero(dataNumRows*dataNumCols,1));
  _labels = Eigen::VectorXi::Zero(numImages);
  double temp; //used for reading values that are ignored

  for (int i = 0; i < numImages; i++)
   {

     //Eigen::MatrixXf debug(64,40);

     
      for (int j = 0; j < dataNumRows; j++)
	{
	  for (int k = 0; k < dataNumCols; k++)
	    {
	      ifs >> _images[i](k+j*dataNumCols,0);
              // debug(j,k) = _images[i](k+j*dataNumCols,0);
	    }
	}
     
      /*******
      if (i == 0)
      {
	matrixSubColToMatrix(_images[i],0,0,debug);
	saveMatrixAsImage("/home/amaas/research/braincode/sdnbranch/matrix.jpg",debug);
      }
      ********/
      if (ifs.fail())
	SDN_DEBUG("failing on " << i);
      SDN_ASSERT(!ifs.fail());

    }

  //Read one more value to see if we are at EOF or not
  ifs >> temp;

  ifs.close();

  _num_labels = _labels.maxCoeff() + 1;

  // _fixDynamicRange(-1.0, 1.0);
}
