//Author: Andrew Maas (amaas)
//File: spectrogramCollectionAMAT.h
//Descript: loads a BasicImageCollection stored as an AMAT dataset
//          Makes assumptions about the size of the data 
// todo: make a superclass for image collections w/ size as variable

#pragma once

#include "basicImageCollection.h"

namespace sdn
{
  /// A BasicImageCollection capable of loading .amat files
/** (This is the file format used for the MNIST Variations
    dataset from University of Montreal) */
  class SpectrogramCollectionAMAT : public BasicImageCollection
  {
  public:
    SpectrogramCollectionAMAT();
    virtual ~SpectrogramCollectionAMAT();

    void load(XMLNode & root);
    
  private:
    int dataNumCols;
    int dataNumRows;
  };
}

//SDN_AUTOREGISTER_H(Dataset, SpectrogramCollectionAMAT);
