//Author: Andrew Saxe <asaxe@stanford.edu>
/** \file architectureUpdateCallback.h
\brief A train runtime callback for adding new architecture to a StackedNetwork.
*/

#pragma once

#include "trainRuntimeManager.h"
#include "sdn/gui.h"
#include <string>

namespace sdn
{

  /// Adds layers to a StackedNetwork.

  class ArchitectureUpdateCallback : public TrainCallback
  {
  public:
    ArchitectureUpdateCallback();
    virtual ~ArchitectureUpdateCallback();
    void callback(TrainState & state);
    
    void load(XMLNode & node);
    
  protected:
    int iter_;
    XMLNode architecture_;
  };
  

}

//SDN_AUTOREGISTER_H(TrainCallback, ArchitectureUpdateCallback);
