/// \author Ian Goodfellow

#pragma once

#include "visualization.h"
#include "../base/attributeParser.h"

class XMLNode;

namespace sdn
{

  /// A WeightVisualizer that shows the image patches from a given dataset that maximall activate each hidden unit in a network (does not calculate optimal input, runs the network on data)
  class BestInputVisualization : public Visualization
  {
  public:
    
    BestInputVisualization();

    std::vector<VisImageSet> makeVisualizations(boost::shared_ptr<Network> network);
    
    void load(XMLNode & node);


  protected:

    AttributeParser p_;
    
  };
}
