/// \author Ian Goodfellow

#pragma once

#include "graphicalTransformer.h"

namespace sdn
{
	/** Layer that applies a graphical transformation to the input. The 	transformation may be changed dynamically. Used to generate 	"positive examples" by transforming a prototypical stimulus. */

	class GraphicalTransformLayer : public Layer
	{
		public:
			GraphicalTransformLayer();
			virtual ~GraphicalTransformLayer();
	
			void  setTransformer(boost::shared_ptr<GraphicalTransformer> transformer);		


		protected:

			boost::shared_ptr<GraphicalTransformer> transformer_;
			boost::const_shared_ptr<Matrix> weights_;
	};
}
