#include "honglakWrapper.h"
#include "../base/matlabEngine.h"
#include <boost/make_shared.hpp>
#include <string>
#include "storageNode.h"

using namespace std;
using namespace sdn;
using namespace boost;

HonglakWrapper::HonglakWrapper()
{
  /// Hack to make it not die
  Network::setInputSize(40,40);

  output_ = make_shared<StorageNode>(1080);

SDN_VERBOSE("Launching matlab engine");
  e_ = getSharedMatlabEngine();
SDN_VERBOSE("Done");

  engEvalString(e_.get(), "cd /afs/cs/u/ia3n/Desktop/honglak2; preload;");

  x_arr_ = mxCreateDoubleMatrix(40,40, mxREAL);


}

HonglakWrapper::~HonglakWrapper()
{
  mxFree(x_arr_);
}


long long HonglakWrapper::train(long long nIter, bool allowHalting)
{
  SDN_FATAL("Honglak networks are not to be trained by mere mortals");
  return 0;
}




void HonglakWrapper::processExampleAsColumn(const Matrix & x)
{
  SDN_FATAL("we don't need this method. just need processExampleToHighestLayer");
}

void HonglakWrapper::forwardPropToHighestLayer(const sdn::Matrix &)
{
  SDN_FATAL("we don't need this method. just need processExampleToHighestLayer");
}


void HonglakWrapper::processExampleToHighestLayer(const sdn::Matrix & x)
{

  memcpy((void *) mxGetPr(x_arr_), x.data(), x.rows()*x.cols()*sizeof(double));

  int result = engPutVariable(e_.get(), "I", x_arr_);

  engEvalString(e_.get(), "l1 = demo_inference(V1,V2,I)");
  
  mxArray * out_arr = engGetVariable(e_.get(), "l1");

  Matrix m(5400,1);

  memcpy( m.data(), (void *)mxGetPr(out_arr), 900*sizeof(double) );

  Matrix m2(1080,1);

  for (int i = 0; i < m2.rows(); i++)
  {
	m2(i,0) = m(i*5,0);
  }

  output_->setActivities(m2);

  mxFree(out_arr);

}







