/// \author Ian Goodfellow

#pragma once
#include "test.h"

namespace sdn
{

  /** A Test that computes (local firing rate) / (global firing rate) 

  See .cc file for rigorous documentation
  */

  class ImplicitPositiveTest : public Test
  {
  public:

    /// returns mean max F score (mean over units, max over thresholds)   and  mean area under PR curve
    std::vector<double> run(boost::shared_ptr<Network> network, boost::shared_ptr<Dataset> dataset);
    virtual void load(XMLNode & node);

  protected:
    int numGlobalPatches_;
    int numLocalTrajectories_;
    double targetFiringRate_;
    boost::shared_ptr<Dataset> testData_;
  };

}
