//Author: Andrew Saxe <asaxe@stanford.edu>
/** \file paramsCallback.h
\brief A train runtime callback for changing layer training parameters
*/

#pragma once

#include "trainRuntimeManager.h"
#include "sdn/gui.h"
#include <string>

namespace sdn
{

  /// Allows parameters of each layer to be set

  class ParamsCallback : public TrainCallback
  {
  public:
    ParamsCallback();
    virtual ~ParamsCallback();
    void callback(TrainState & state);
    
    void load(XMLNode & node);
    
  protected:
    int iter_;
    XMLNode params_;
  };
  

}

//SDN_AUTOREGISTER_H(TrainCallback, ParamsCallback);
