//Author: Ian Goodfellow <ia3n@cs.stanford.edu>
/** \file recordCallback.h
\brief A train runtime callback for visualizing patches and
      their reconstructions
*/

#pragma once

#include "trainRuntimeManager.h"
#include "sdn/gui.h"
#include <string>

namespace sdn
{

  /// Periodically displays training patches and their reconstructions

  class PatchVizCallback : public TrainCallback
  {
  public:
    PatchVizCallback();
    virtual ~PatchVizCallback();
    void callback(TrainState & state);
    
    void load(XMLNode & node);
    
  protected:
    boost::shared_ptr<PatchDisplay> _viz;
    int _step; /// \todo correct style. Should have ending underscores
    bool _showImage;
    bool _saveFile;
    bool normalize_contrast_;
    std::string _filepath;
};


}

//SDN_AUTOREGISTER_H(TrainCallback, PatchVizCallback);
