//Author: Quoc V. Le <quocle@cs.stanford.edu>
// \file saveFileCallback.h
// \brief A train runtime callback for saving network files

#pragma once

#include "trainRuntimeManager.h"
#include <vector>
#include <sstream>

namespace sdn
{


  /// \todo-- write load method so this can be invoked from the config manager; QVL: this class doesn't seem to do anything, should we just remove it?
class SaveFileCallback : public TrainCallback {
  private:
    std::string basename_;
    int step_;
  public:
    SaveFileCallback() : TrainCallback(0) {
    }
      
    
    virtual ~SaveFileCallback() {}

  void callback(TrainState& state) { 
    SDN_DEBUG("Running saving file callback");
    
    std::cout << "saving to file " << basename_ << std::endl;
    
    std::stringstream iter_name; 
    
    iter_name << basename_ << "_" << state.iter << ".dat";
    
    assert(state.iter == nextIter); 
    
    state.network->save(iter_name.str().c_str(), serial::BIN);		
    nextIter += step_;
    
  }
  
  void load(XMLNode & node)
  {
    SDN_ASSERT(node.getName());
    SDN_ASSERT(std::string("sdn::TrainCallback")==node.getName());
    SDN_ASSERT(node.getAttribute("id"));
    SDN_ASSERT(std::string("sdn::SaveFileCallback")==node.getAttribute("id"));
    const char * stepStr = node.getAttribute("step");
    if (stepStr)
      step_ = atoi(stepStr);
    const char * basename = node.getAttribute("basename");
    if (basename)
      basename_ = basename;
  }
  

};

}
