/// \author Ian Goodfellow

#pragma once


#include "standardLayer.h"
#include "storageNode.h"
#include <vector>

namespace sdn
{



class SimpleClassifier
{
 public:

  SimpleClassifier();

  /// Train until convergence. Each row of X is an example, y a vector of class labels
  void train(const Matrix & X, const std::vector<unsigned> & y);
  /// y is a distribution over classes
  void getProbabilities(const Vector & x, Vector & y);

  unsigned getClass(const Vector & x);

  /// Each row of X is an example, each row of Y is a distribution over classes
  void getMatrixProbabilities(const Matrix & X,  Matrix & Y);
  
  //returns proportion of misclassifications
  double error(const Matrix & X, const  std::vector<unsigned> & y);

  void getClasses(const Matrix & X,  std::vector<unsigned> & y);

 protected:

  StandardLayer layer_;
  StorageNode input_;
  StorageNode output_;

};


}
