#include <Eigen/Core>
#include <Eigen/Array>
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <stdlib.h>

#include "templateMatching.h"
#include "sdn/dataset.h"

USING_PART_OF_NAMESPACE_EIGEN // import most common Eigen types 

using namespace sdn;
using namespace std;


TemplateMatching::TemplateMatching(){
  _value = 0;
}
void TemplateMatching::setTemplate(const Matrix t){
  _template = t;
  _template_norm2 = (_template.cwise() * _template).sum();
}

void TemplateMatching::forwardProp(const Matrix x){
  assert(_template.rows() == x.rows() && _template.cols() == x.cols());
  //_value = ((_template.cwise() * x).sum()) / _template_norm2 ; // tanh template matching
  Matrix temp = _template -  x; 
  Matrix dotproduct_temp = temp.cwise() * temp;
  Scalar norm_temp = dotproduct_temp.sum();  
  _value = exp( - norm_temp / (_template_norm2) ); // rbf template matching
  
}

Scalar TemplateMatching::getActivation(){
  return min(max(_value,Scalar(-1.0)),Scalar(1.0));
}

