//Author: Quoc V. Le

/**
   \file templateMatchingNetwork.h
   \brief Implements a template matching network
*/ 
#pragma once

#include <string>
#include "../base/matrix.h"
#include "../dataset/gratingTestDataset.h"
#include "../dataset/naturalTestDataset.h"

namespace sdn{
  class TemplateMatching
  {
  protected: 
    Matrix _template;
    Scalar _value;
    Scalar _template_norm2;
  public: 
    TemplateMatching();
    void setTemplate(const Matrix t);
    void forwardProp(const Matrix x);
    Scalar getActivation();
  };
}
