/// \author Ian Goodfellow

#pragma once

#include "network.h"

namespace sdn
{

  ///An abstract base class for running tests, such as invariance metrics, on a network
  class Test
  {
  public:
    /**
	\param network The network to test
	\param dataset The dataset the network is being trained on 
	(if you want to run the test on a different dataset, communicate this 
	through the load(XMLNode) method)
    */
    virtual std::vector<double> run(boost::shared_ptr<Network> network, boost::shared_ptr<Dataset> dataset) = 0;
    virtual void load(XMLNode & node) = 0;
  };

  Registry<Test> & TestRegistry();
}
