///\author Ian Goodfellow

#pragma once

#include "trainRuntimeManager.h"
#include <vector>


namespace sdn
{
  class Test;
  
  
  /** A TrainCallback for running a Test on a network */      
  class TestCallback : public TrainCallback {

  public:
    
    TestCallback() : TrainCallback(0) {}
      
      virtual ~TestCallback() {}
      
      void callback(TrainState& state);
      
      /** XMLNode should contain the attribute "step", the attribute "filename" 
	  specifying where to write the output, and a child of type sdn::Test */
      void load(XMLNode & node);
      
  protected:
      int step_;
      std::ofstream saveFile_;
      boost::shared_ptr<Test> test_;
  };
  
}


//SDN_AUTOREGISTER_H(TrainCallback, GratingTestQuantileThresholdCallback);
