/// \author Ian Goodfellow
#include "reconstructionVisualization.h"
#include "visualization.h"
#include "../base/registry.h"
#include "linearVisualization.h"
#include "bestInputVisualization.h"
using namespace sdn;

Registry<Visualization> & sdn::VisualizationRegistry()
{
  static Registry<Visualization> registry("sdn::Visualization");
  return registry;
}

SDN_AUTOREGISTER(Visualization, LinearVisualization);
SDN_AUTOREGISTER(Visualization, BestInputVisualization);
SDN_AUTOREGISTER(Visualization, ReconstructionVisualization);

