//Author: Daniel Chia <danchia@stanford.edu>
//File: danchiaConvertNetworkInScript.h
//Description: 

#pragma once

#include "boost/shared_ptr.hpp"
#include "sdn/stable.h"
#include "../blocks/crossValidationBlock.h"

namespace sdn {

  // Forward Declarations
  class Dataset;

  /// DanchiaConvertNetworkInScript class
  /** 
  */
  class DanchiaConvertNetworkInScript : public AbstractScript {

  public:
  

    virtual void loadXML(XMLNode& node);

    virtual void initTransientParameters(); 
    virtual void initPersistentParameters();

    virtual void serialize(serial::Archive & ar);

    virtual void loadUsingConfigManager();

    virtual void executeOneIteration();
    
    DanchiaConvertNetworkInScript();
    ~DanchiaConvertNetworkInScript();

    // Configurable       
		std::string networkFile;
		std::string saveDir;

    // Persistent Parameters
   	 
    // Transient
		boost::shared_ptr<StandardAutoEncoderNetwork> network;
  };
  
  
}
