//Author: Daniel Chia
//File: danchiaConvertNetworkOutScript.h
//Description: 

#pragma once

#include "boost/shared_ptr.hpp"
#include "sdn/stable.h"

namespace sdn {

  // Forward Declarations
  class Dataset;

  /// DanchiaConvertNetworkOutScript class
  /** 
  */
  class DanchiaConvertNetworkOutScript : public AbstractScript {

  public:
  

    virtual void loadXML(XMLNode& node);

    virtual void initTransientParameters(); 
    virtual void initPersistentParameters();

    virtual void serialize(serial::Archive & ar);

    virtual void loadUsingConfigManager();

    virtual void executeOneIteration();
    
    DanchiaConvertNetworkOutScript();
    ~DanchiaConvertNetworkOutScript();

    // Configurable       
    std::string saveDir;
		std::string networkName;

    // Configurable-Persistent Parameters
    boost::shared_ptr<StandardAutoEncoderNetwork> network;
    
    // Transient
    
    // Fixed Parameters
	private:
		void readMatrix(std::ifstream &stream, Matrix &m);
  };
  
  
}
