//Author: Daniel Chia <danchia@stanford.edu>
//File: danchiaCrossValidationScript.h
//Description: 

#pragma once

#include "boost/shared_ptr.hpp"
#include "sdn/stable.h"
#include "../blocks/crossValidationBlock.h"

namespace sdn {

  // Forward Declarations
  class Dataset;

  /// DanchiaCrossValidationScript class
  /** 
  */
  class DanchiaCrossValidationScript : public AbstractScript {

  public:
  

    virtual void loadXML(XMLNode& node);

    virtual void initTransientParameters(); 
    virtual void initPersistentParameters();

    virtual void serialize(serial::Archive & ar);

    virtual void loadUsingConfigManager();

    virtual void executeOneIteration();
    
    DanchiaCrossValidationScript();
    ~DanchiaCrossValidationScript();

    // Configurable       
		std::string supervisedNetworkFile;
		unsigned int startIteration;
		unsigned int iterationsPerStep;

    // Persistent Parameters
   	 
    // Transient
    CrossValidationBlock crossValidationBlock;
		boost::shared_ptr<AbstractSupervisedNetwork> supervisedNetwork;
    
  };
  
  
}
