//Author: NAME <name@cs.stanford.edu>
//File: composableBlockTemplate.cc
//Description: 

#include "composableBlockTemplate.h"
#include "composableBlocks.h"
#include "standardBlocks.h"
#include "sdn/base.h"
#include <Eigen/Array>

namespace sdn {
  
  // MyNewComposableBlock ------------------------------------------------
  
  MyNewComposableBlock::MyNewComposableBlock() {
    SDN_FATAL(className() << " is meant as a template!");
  }
  
  MyNewComposableBlock::~MyNewComposableBlock() {
  }

  void MyNewComposableBlock::loadXML(XMLNode& node) {

    AttributeParser p;

    p.addDouble("myDoubleParameter");
    p.addInt("myIntParameter");
        
    p.parse(node);

    myDoubleParameter = p.getDouble("myDoubleParameter");
    myIntParameter = p.getInt("myIntParameter");
        
    initPersistentParameters();
    initTransientParameters();

  }
  
  void MyNewComposableBlock::initTransientParameters() {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }
  
  void MyNewComposableBlock::initPersistentParameters() {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }
  
  void MyNewComposableBlock::serialize(serial::Archive & ar) {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }
  
  void MyNewComposableBlock::forwardProp(const sdn::Matrix& input,
                               sdn::Matrix& output) {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }
 
  void MyNewComposableBlock::backProp(const sdn::Matrix& input,
                            const sdn::Matrix& outputDerivatives,
                           sdn::Matrix& inputDerivatives) {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }
  
  void MyNewComposableBlock::gradientUpdate() {
    SDN_FATAL(className() << " " << std::string(__FUNCTION__) << " not implemented yet");
  }


  
}
