//Author: NAME <name@cs.stanford.edu>
//File: composableBlockTemplate.h
//Description: 

#pragma once

#include "sdn/base.h"
#include "defaultParameters.h"
#include "../abstractBlock.h"
#include "sharedBlocks.h"
#include <Eigen/Array>

namespace sdn {

  /// MyNewComposableBlock class
  /** Describe your composableblock here
   * 
   *  After implementing it, add this to 
   *     the Makefile (src/lib/Makefile)
   *     ComposableBlockRegistry (composableBlockRegistry.h)
   *  
   *  and you're all set !
  */
  class MyNewComposableBlock : public ComposableBlock {
  
  public:
  
    virtual void loadXML(XMLNode& node);
    
    virtual void initTransientParameters() ;
    virtual void initPersistentParameters();
    
    virtual void serialize(serial::Archive & ar);
    
    MyNewComposableBlock();
    ~MyNewComposableBlock();

    // Configurable Parameters
    // Put your configurable parameters here, e.g. learning rates, etc
    sdn::Scalar myDoubleParameter;
    int myIntParameter;
    
    // Persistent Parameters
    // Put your persistent parameters here, e.g. weights, bias
    
    // Transient Parameters
    // Put your persistent parameters here, e.g. gradients
    
    // Composable Block Operations
    virtual void forwardProp(const sdn::Matrix& input,
                             sdn::Matrix& output);
   
    virtual void backProp(const sdn::Matrix& input,
                          const sdn::Matrix& outputErrorDerivatives,
                          sdn::Matrix& inputErrorDerivatives);
    
    virtual void gradientUpdate();
    
  };
  
}
