//Author: Jiquan Ngiam <jngiam@cs.stanford.edu>
//File: jngiamHelpers.h
//Description: Helpers

#pragma once

#include "sdn/base.h"
#include "sdn/stable.h"

namespace sdn {
  
  class ComputeColwiseWeightedKurtBlock : public AbstractBlock {

  public:

    virtual void loadXML(XMLNode& node) {}
    virtual void initTransientParameters() {}
    virtual void initPersistentParameters() {}
    virtual void serialize(serial::Archive & ar) {}
    
    Matrix computeColwiseWeightedKurt(const Matrix& m, const Matrix& w);
    
    // In a block, saves on time on alloc/dealloc
    // Each of these represent the n-th central moment
    Matrix unitX, unitX2, unitX4, kurt, wNorm;
    
  };

  
  
  // Move to a block
  Matrix computeColwiseKurtosis(const Matrix& m);


}
