//Author: NAME <name@stanford.edu>
//File: jngiamScript1.h
//Description: 

#pragma once

#include "boost/shared_ptr.hpp"
#include "sdn/stable.h"

namespace sdn {

  // Forward Declarations
  class Dataset;

  /// JngiamScript1 class
  /** 
  */
  class JngiamScript1 : public AbstractScript {

  public:
  

    virtual void loadXML(XMLNode& node);

    virtual void initTransientParameters(); 
    virtual void initPersistentParameters();

    virtual void serialize(serial::Archive & ar);

    virtual void loadUsingConfigManager();

    virtual void executeOneIteration();
    
    JngiamScript1();
    ~JngiamScript1();

    // Configurable       
    std::string datasetName;
    int inputHeight;
    int inputWidth;

    // Configurable-Persistent Parameters
    
    // Transient
    boost::shared_ptr<Dataset> dataset;
    sdn::Matrix inputExample, sumInputAbs, sumInputL2, sumNoScale;
    double absSum, l2Sum, seen, pxsum, mmax, mmin;
    int outlier;

    ExponentiallyWeightedMeanBlock l2AveErrorTracker;
    ExponentiallyWeightedMeanBlock absAveErrorTracker;
    ExponentiallyWeightedMeanBlock noScaleErrorTracker;
    ExponentiallyWeightedMeanBlock zeroErrorTracker;


    
    // Fixed Parameters
    NormalizeInputBlock normInput;
    SumOfSquaresCostFunction costFunc;
  };
  
  
}
