//Author: Daniel Chia, Zhenghao Chen, Pang Wei Koh
//File: invarianceTweakingStandardNetwork.cc
//Description: Standard network for artificial invariance boosting

#include "../../../stable/blocks/sharedBlocks.h"
#include "invarianceTweakingStandardNetwork.h"
#include "sdn/base.h"
#include <boost/shared_ptr.hpp>
#include <Eigen/Array>

namespace sdn {

	void InvarianceTweakingStandardNetwork::unsupervisedTrain() {


//		if (reconstruction.size() != example.size()) {
//			reconstruction = sdn::Matrix::Zero(example.rows(), example.cols());
//			affineRepDec = sdn::Matrix::Zero(example.rows(), example.cols());
//		}

		std::cout << "one iteration of unsupervisedTrain()" << std::endl;
		std::cout << "does this have anything?" << std::endl;
		std::cout << affineEncoder.biasGradient << std::endl;
		std::cout << "guess so" << std::endl;
		invTestBlock.computeGradient(affineEncoder.weightsGradient, affineEncoder.biasGradient);

		// Forward Propagate

		//	 encode(example);

		//decode(hiddenRepresentation);

		// Present Example
		// outputGradient = costFunc->jacobian(reconstruction, example).transpose();

		//outputGradient = -1;

		// Back Prop
		//decodeBackProp( hiddenRepresentation, outputGradient, hiddenGradient);
		//encodeBackProp( example, hiddenGradient, inputGradient);

		// Gradient Updates (weight decay is performed in the affineEncoder itself)
	//	gradientUpdate();

		encodeGradientUpdate();

		// ============== ADDITIONAL OPERATIONS ==============

		// Sparsity Updates
//		activationTracker.addValues( sigmEncoder.normalizeActivationValues( hiddenRepresentation ) );
//		sdn::Matrix sparsityError = activationTracker.getMean().cwise() - targetActivation;
//		affineEncoder.bias -= affineEncoder.learningRate*learningRateSparsity*sparsityError;

	}

	// --------------------------------------------------------------------------

	void InvarianceTweakingStandardNetwork::loadXML(XMLNode& node) {

		AttributeParser p;

		p.parse(node);

		XMLNode invarianceTestNode = node.getChildNode("InvarianceTestParameters");
    	SDN_ASSERT_MSG(!invarianceTestNode.isEmpty(), "You need to specify <InvarianceTestParameters> !")
		
		invTestBlock.loadXML (invarianceTestNode);
		
		initPersistentParameters();
		initTransientParameters();

	}

	void InvarianceTweakingStandardNetwork::initTransientParameters() {

	//	activationTracker.setConfigurableParameters(activationAveragingConstant,
//				targetActivation,
//				SIZE_AUTOSET);

	}

	void InvarianceTweakingStandardNetwork::initPersistentParameters() {

		affineEncoder.initPersistentParameters();

		sigmEncoder.initPersistentParameters();

		invTestBlock.initializeGradient(patchWidth, patchHeight, invType);


	}


	void InvarianceTweakingStandardNetwork::serialize(serial::Archive & ar)  {
		SDN_DEBUG(className() << "::" << __FUNCTION__);
		int version = 1000;

		version = ar.beginBase(this,version,className());

		switch(version)
		{
			case 1000:

				// Persistent
				affineEncoder.serialize(ar);
				sigmEncoder.serialize(ar);
			
				// Configurable
				ar.attribute("targetActivation", targetActivation);
				ar.attribute("activationAveragingConstant", activationAveragingConstant);
				ar.attribute("hiddenLayerSize", hiddenLayerSize);
				ar.attribute("learningRateSparsity", learningRateSparsity);
				
				break;

			default:
				SDN_FATAL("Unrecognized " << className() << " version");
		}
		ar.endBase();

		// Input Case: Initialize Transient
		if (ar.in()) {
			initTransientParameters();
		}

	}

	InvarianceTweakingStandardNetwork::~InvarianceTweakingStandardNetwork() {
	}


}
