//Author: Daniel Chia, Zhenghao Chen, Pang Wei Koh
//File: invarianceTweakingStandardNetwork.h
//Description: Standard network for artificial invariance boosting

#pragma once

#include "sdn/base.h"
#include "../../../stable/abstractNetwork.h"
#include "../../../stable/networks/standardAutoEncoderNetwork.h"
#include "../../../stable/blocks/sharedBlocks.h"
#include "../../../stable/blocks/standardBlocks.h"
#include "../blocks/invarianceTestBlock.h"
#include <boost/shared_ptr.hpp>

namespace sdn {

  /// InvarianceTweakingStandardNetwork class
  /** 
  */
  class InvarianceTweakingStandardNetwork : public StandardAutoEncoderNetwork {
  public:

    virtual void loadXML(XMLNode& node) ;
    
    virtual void initTransientParameters();
    virtual void initPersistentParameters();
    
    virtual void serialize(serial::Archive & ar) ;
    
    virtual void unsupervisedTrain();
    
    InvarianceTweakingStandardNetwork() {};
    virtual ~InvarianceTweakingStandardNetwork();

    // Persistent Parameters
    InvarianceTestBlock invTestBlock;

    // Configurable Parameters
    
	 int patchWidth;
	 int patchHeight;
	 int invType;

    // Transient Parameters
    
    // Fixed Parameters, could technically load this 
  };

}
  
