//Author: Daniel Chia, Zhenghao Chen, Pang Wei Koh
//File: invarianceScript.h
//Description: 

#pragma once

#include "boost/shared_ptr.hpp"
#include "sdn/stable.h"
#include "./callbacks/invarianceCallbacks.h"
#include "../networks/invarianceNetwork.h"

namespace sdn {

  // Forward Declarations
  class Dataset;

  /// InvarianceScript class
  /** 
  */
  class InvarianceScript : public AbstractScript, 
								public InvarianceCallbackInterface	{

  public:
  

    virtual void loadXML(XMLNode& node);

    virtual void initTransientParameters(); 
    virtual void initPersistentParameters();

    virtual void serialize(serial::Archive & ar);

    virtual void loadUsingConfigManager();

    virtual void executeOneIteration();
    
    InvarianceScript();
    virtual ~InvarianceScript();

    // Configurable       
    std::string networkFile;
	 int patchHeight;
	 int patchWidth;

//	boost::shared_ptr<InvariantNetwork> inetwork;
	InvarianceNetwork inetwork;

    // Configurable-Persistent Parameters
        
    // Transient
	 boost::shared_ptr<AbstractAutoEncoderNetwork> network;
	//boost::shared_ptr<InvarianceNetwork> network;

    // Fixed Parameters
       
	 // ---- Invariance Callback ----
	 
    virtual const boost::shared_ptr<sdn::AbstractAutoEncoderNetwork> getNetwork();
 
  };
  
  
}
