//Author: Jiquan Ngiam <jngiam@cs.stanford.edu>
//File: composableBlockRegistry.cc
//Description: Sets up the registry of composable blocks


#include "composableBlockRegistry.h"
#include "sdn/base.h"

// Stable Blocks
#include "../stable/blocks/sharedBlocks.h"
#include "../stable/blocks/standardBlocks.h"

// Project Blocks

namespace sdn {

  Registry<ComposableBlock>& ComposableBlockRegistry() {
    static Registry<ComposableBlock> registry("sdn::ComposableBlock");
    return registry;
  }

 
}


// Basic Composable
SDN_AUTOREGISTER(ComposableBlock, AffineBlock);
SDN_AUTOREGISTER(ComposableBlock, TanhBlock);
SDN_AUTOREGISTER(ComposableBlock, SoftmaxBlock);
SDN_AUTOREGISTER(ComposableBlock, ScaleBlock);

// Affine + Activation Composable
SDN_AUTOREGISTER(ComposableBlock, AffineTanhBlock);
SDN_AUTOREGISTER(ComposableBlock, AffineSoftmaxBlock);

// More Complicated Stuff
SDN_AUTOREGISTER(ComposableBlock, SparseAffineTanhBlock);

/* 
 * ADDING NEW BLOCKS? 
 * 
 * Follow the line below
 * 
 */

// SDN_AUTOREGISTER(ComposableBlock, MyNewComposableBlock);

