//Author: Andrew Maas <amaas@cs.stanford.edu>
//File: vizWeightMatrixBlock.h
//Description: Implementation of generic blocks used everywhere

#pragma once

#include "sdn/base.h"
#include "../defaultParameters.h"
#include "../abstractBlock.h"
#include <string>

namespace sdn {

  class VizWeightMatrixBlock : public AbstractBlock {

  public:
  
    virtual void loadXML(XMLNode& node) {}
    virtual void initTransientParameters() {}
    virtual void initPersistentParameters() {}
    virtual void serialize(serial::Archive & ar) {}

    /**
     * Takes a weight matrix and displays it to screen or writes to file.
     * @param w is the weight matrix where each row is a unit
     * @param pHeight is the number of rows in a unit's receptive field
     *        (the width / number of columns is inferred)
     * @param gridWidth is the number of columnss in the displayed grid
     *        (the number of rows is inferred)
     * @param saveName is full path/name to save image. Set empty string to not save anything
     * @param disp specifies whether to display the image on screen now
     */
    virtual void vizMatrix(const sdn::Matrix& w, int pHeight, 
         int gridWidth,
         std::string saveName, bool disp = false);

  };
}
