/// \author Ian Goodfellow
#include "normPenalty.h"
#include <Eigen/Core>
#include <Eigen/Array>

using namespace sdn;

L2Penalty::L2Penalty()
{
}

L2Penalty::~L2Penalty()
{
}

Matrix L2Penalty::output(const Matrix & m) {
  return Matrix::Constant(1,1,m.cwise().square().sum()/2.0);
}

Matrix L2Penalty::matrixDerivative(const Matrix & m) {
  return m;
}

void L2Penalty::serialize(serial::Archive & ar)
{
  
  SDN_DEBUG("L2Penalty::Serialize");
  
  int version = 211;
  
  version = ar.beginDerived(this,version,"sdn::L2Penalty");
  
  switch (version)
    {
    case 211:
      ar.beginSuper();
      UnaryObjectiveTerm::serialize(ar);
      ar.endSuper();
      
      ar.endDerived();
      break;
    default:
      SDN_FATAL("Unrecognized sdn::L2Penalty version");
    }
}
