/// \author Ian Goodfellow
/// \file normPenalty.h
/// \brief Implements a variety of norm penalties

#include "unaryObjectiveTerm.h"

#pragma once

namespace sdn
{
  
  /// L2 penalty objective term
  class L2Penalty : public UnaryObjectiveTerm
  {
  public:

    L2Penalty();
    virtual ~L2Penalty();

    /// returns $ \frac{1}{2} || m ||_2^2 $
    Matrix output(const Matrix & m);

    Matrix matrixDerivative(const Matrix & m);

    void serialize(serial::Archive & ar);    
  };

}
