/// \author Ian Goodfellow

#include "normPenalty.h"
#include "unaryObjectiveTerm.h"
#include "sdn/base.h"


using namespace sdn;



void UnaryObjectiveTerm::serialize(serial::Archive & ar)
{
  
  SDN_DEBUG("UnaryObjectiveTerm::Serialize");
  
  int version = 211;
  
  version = ar.beginBase(this, version, "sdn::UnaryObjectiveTerm");

  switch(version)
  {
	case 211:
		ar.attribute("lambda", lambda);
      		serialize_shared_ptr(ar, arg_, MatrixSerializer());
		ar.endBase();
		break;
	default:
		SDN_FATAL("unrecognized version");
  }

/*
  version = ar.beginDerived(this,version,"sdn::UnaryObjectiveTerm");
  
  switch (version)
    {
    case 211:
      ar.beginSuper();
      ObjectiveTerm::serialize(ar);
      ar.endSuper();

      //Serialize the shared pointer to the argument

      serialize_shared_ptr(ar, arg_, MatrixSerializer());
      ar.endDerived();
      break;
    default:
      SDN_FATAL("Unrecognized UnaryObjectiveTerm version");
    }
  */  
}

Registry<UnaryObjectiveTerm> & sdn::UnaryObjectiveTermRegistry()
{
  static Registry<UnaryObjectiveTerm> registry("sdn::UnaryObjectiveTerm");
  return registry;
}

SDN_AUTOREGISTER(UnaryObjectiveTerm, L2Penalty);
