//Author: Jiquan Ngiam <jngiam@cs.stanford.edu>
//File: scriptRuntimeManager.h
//Description: Loads up a script / dataset and runs stuff !


#pragma once

#include "abstractScript.h"
#include "boost/shared_ptr.hpp"
#include "sdn/base.h"

namespace sdn {

  class ScriptRuntimeManager {

  protected:
    std::string className() {
      return std::string(demangle(typeid(*this).name()));
    }

  public:
  
    void loadCallBack(XMLNode& node);
    void loadXML(XMLNode& node);
    
    void init();
    void run();
    
    ScriptRuntimeManager();
    ~ScriptRuntimeManager();
    
    // Configurable
    std::string scriptName;
    int trainIterations;
    
    // Transient
    boost::shared_ptr<Script> script;
    std::vector<boost::shared_ptr<ScriptCallback> > callbacks;
    std::vector<long int> callbackNextIter;
    int currentIteration;

  };
  
}
