/// \author Ian Goodfellow
/// Pre-SDN code included to support stackedEncoder

#pragma once
#include <string>
#include <map>
#include <vector>

#include "sdn/base.h"


//Reads a log file, returns name of experiment or empty string on failure
//Populates output map-- string key is column name, vector value is column contents
//Note- the log file also contains a record of the command that was run. this function just skips over that
std::string parseLog(const std::string & filepath, std::map<std::string, std::vector<double> > & output);

//Math functions used by various neural networks
//Reciprocal of the number of overlaps occurring at point (i,j) in an image
sdn::Scalar averagingWeight(int i, int j, int patchStep, int inputWidth, int numStep);
sdn::Scalar sigmoidInverse(sdn::Scalar x);
