#include "sdn/old.h"
#include <Eigen/Core>
#include <Eigen/Array>
#include "gtest/gtest.h"

using namespace sdn;

TEST(StorageNode, Constructor) {
  int size = 10;
  StorageNode sl(size);
  EXPECT_EQ(sl.size(), size);
  EXPECT_EQ(sl.getActivities().rows(), size);
  EXPECT_EQ(sl.getDerivatives().rows(), size);
}

TEST(StorageNode, Assignment) {
  int size = 2;
  StorageNode sl(size);
  Matrix tmp2;
  {
    Matrix tmp = Matrix::Random(size, 5);
  
    sl.setActivities(tmp);
    sl.setDerivatives(tmp);
    
    tmp2 = tmp;
  }
  EXPECT_TRUE(sl.getActivities() == tmp2);
  EXPECT_TRUE(sl.getDerivatives() == tmp2);
}
