/// \author Ian Goodfellow
#include "weightConversion.h"
using namespace sdn;
using namespace std;

Matrix stackedEncoderToStandardLayerWeights(const vector<vector<Matrix> > & ew)
{
  Matrix ewn = Matrix::Zero(ew.size() * ew[0].size(), ew[0][0].rows()*ew[0][0].cols());
  for (unsigned i = 0; i < ew.size(); i++)
    {
      for (unsigned j = 0; j < ew[i].size(); j++)
	{
	  unsigned k = vectorCoord(i,j,ew.size(),ew[i].size());
	  ewn.row(k) = matrixToVector(ew[i][j]).transpose();
	}
    }
  return ewn;
}


Matrix stackedEncoderToStandardLayerBiases(const Matrix & b)
{
  return matrixToVector(b);
}
